//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%4628FC6703BB.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%4628FC6703BB.cm

//## begin module%4628FC6703BB.cp preserve=no
//## end module%4628FC6703BB.cp

//## Module: Randomizer%4628FC6703BB; Package specification
//## Subsystem: XSFit::Randomizer%4628FB3101C3
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/Randomizer/Randomizer.h

#ifndef RANDOMIZER_H
#define RANDOMIZER_H 1

//## begin module%4628FC6703BB.additionalIncludes preserve=no
//## end module%4628FC6703BB.additionalIncludes

//## begin module%4628FC6703BB.includes preserve=yes
//## end module%4628FC6703BB.includes

// xsTypes
#include <main/xsTypes.h>
// Fit
#include <XSFit/Fit/Fit.h>
// RandomizerBase
#include <XSFit/Randomizer/RandomizerBase.h>
//## begin module%4628FC6703BB.declarations preserve=no
//## end module%4628FC6703BB.declarations

//## begin module%4628FC6703BB.additionalDeclarations preserve=yes
#include <XSFit/Randomizer/RandomizerPolicies.h>
//## end module%4628FC6703BB.additionalDeclarations


//## begin Randomizer%4629005600BB.preface preserve=yes
#include <XSUtil/Error/Error.h>
//## end Randomizer%4629005600BB.preface

//## Class: Randomizer%4629005600BB; Parameterized Class
//	This is a host class to combine the policy and trait
//	classes for determining:  1.  The source of the variance
//	information, and 2.  The randomizing distribution
//	function.
//## Category: XSFit::Randomizer%4628FCF800E6
//## Subsystem: XSFit::Randomizer%4628FB3101C3
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%462902C9034C;RealArray { -> }
//## Uses: <unnamed>%462904650005;Fit { -> }

template <class Source, class Dist>
class Randomizer : public RandomizerBase  //## Inherits: <unnamed>%4629007402BE
{
  //## begin Randomizer%4629005600BB.initialDeclarations preserve=yes
  //## end Randomizer%4629005600BB.initialDeclarations

  public:
    //## Constructors (generated)
      Randomizer();

      Randomizer(const Randomizer< Source,Dist > &right);

    //## Destructor (generated)
      virtual ~Randomizer();

    // Additional Public Declarations
      //## begin Randomizer%4629005600BB.public preserve=yes
      //## end Randomizer%4629005600BB.public

  protected:
    // Additional Protected Declarations
      //## begin Randomizer%4629005600BB.protected preserve=yes
      //## end Randomizer%4629005600BB.protected

  private:

    //## Other Operations (specified)
      //## Operation: doRandomize%462904AB0231
      //	Note that this host class makes no use of the Fit
      //	pointer passed as a function argument, which is
      //	redundant with the Source trait classes.  It is included
      //	as part of the  interface though for the benefit of
      //	users who wish to write their own non-templated subclass
      //	of RandomizerBase.
      virtual void doRandomize (RealArray& parameterValues, const Fit* fit);

      //## Operation: doInitializeRun%462CDE880086
      virtual void doInitializeRun (const Fit* fit);

      //## Operation: apply%4652F2E600C4
      void apply (const RealArray& randVals, RealArray& parameterValues) const;

      //## Operation: getCovariance%4665867500BA
      virtual const RealArray* getCovariance (const Fit* fit);

      //## Operation: doInitializeLoad%4666D6120064
      virtual void doInitializeLoad ();

    // Additional Private Declarations
      //## begin Randomizer%4629005600BB.private preserve=yes
      //## end Randomizer%4629005600BB.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: sourceInfo%462D199A0159
      //## begin Randomizer::sourceInfo%462D199A0159.attr preserve=no  private: RandomizerSourceInfo<Source> {U} 
      RandomizerSourceInfo<Source> m_sourceInfo;
      //## end Randomizer::sourceInfo%462D199A0159.attr

    // Additional Implementation Declarations
      //## begin Randomizer%4629005600BB.implementation preserve=yes
      //## end Randomizer%4629005600BB.implementation

};

//## begin Randomizer%4629005600BB.postscript preserve=yes
//## end Randomizer%4629005600BB.postscript

// Parameterized Class Randomizer 

// Parameterized Class Randomizer 

template <class Source, class Dist>
Randomizer<Source,Dist>::Randomizer()
  //## begin Randomizer::Randomizer%4629005600BB_const.hasinit preserve=no
  //## end Randomizer::Randomizer%4629005600BB_const.hasinit
  //## begin Randomizer::Randomizer%4629005600BB_const.initialization preserve=yes
  :RandomizerBase(Dist::name + string(" ") + RandomizerSourceInfo<Source>::name),
   m_sourceInfo()
  //## end Randomizer::Randomizer%4629005600BB_const.initialization
{
  //## begin Randomizer::Randomizer%4629005600BB_const.body preserve=yes
  //## end Randomizer::Randomizer%4629005600BB_const.body
}

template <class Source, class Dist>
Randomizer<Source,Dist>::Randomizer(const Randomizer<Source,Dist> &right)
  //## begin Randomizer::Randomizer%4629005600BB_copy.hasinit preserve=no
  //## end Randomizer::Randomizer%4629005600BB_copy.hasinit
  //## begin Randomizer::Randomizer%4629005600BB_copy.initialization preserve=yes
  :RandomizerBase(right),
   m_sourceInfo(right.m_sourceInfo)
  //## end Randomizer::Randomizer%4629005600BB_copy.initialization
{
  //## begin Randomizer::Randomizer%4629005600BB_copy.body preserve=yes
  //## end Randomizer::Randomizer%4629005600BB_copy.body
}


template <class Source, class Dist>
Randomizer<Source,Dist>::~Randomizer()
{
  //## begin Randomizer::~Randomizer%4629005600BB_dest.body preserve=yes
  //## end Randomizer::~Randomizer%4629005600BB_dest.body
}



//## Other Operations (implementation)
template <class Source, class Dist>
void Randomizer<Source,Dist>::doRandomize (RealArray& parameterValues, const Fit* fit)
{
  //## begin Randomizer::doRandomize%462904AB0231.body preserve=yes
   // Can ASSUME parameterValues contains current values of
   // all variable fit parameters.
   const size_t nPars = parameterValues.size();
   const RealArray& scaling = m_sourceInfo.eigenValues();
   if (nPars != scaling.size())
   {
      throw RedAlert("Array size mismatch in Randomizer<Source,Dist>::doRandomize.");
   }
   RealArray randVals(.0,nPars);
   Dist::getValuesFromDistribution(scaling, randVals);
   apply(randVals, parameterValues);
  //## end Randomizer::doRandomize%462904AB0231.body
}

template <class Source, class Dist>
void Randomizer<Source,Dist>::doInitializeRun (const Fit* fit)
{
  //## begin Randomizer::doInitializeRun%462CDE880086.body preserve=yes
   m_sourceInfo.fillVarInfo(fit);
  //## end Randomizer::doInitializeRun%462CDE880086.body
}

template <class Source, class Dist>
void Randomizer<Source,Dist>::apply (const RealArray& randVals, RealArray& parameterValues) const
{
  //## begin Randomizer::apply%4652F2E600C4.body preserve=yes
   const size_t nPars = parameterValues.size();
   const RealArray& eVector = m_sourceInfo.eigenVectors();
   if (eVector.size() != nPars*nPars)
   {
      string errMsg("Eigenvector size mismatch in Randomizer<Source,Dist>::apply.");
      throw RedAlert(errMsg);
   }
   RealArray sigma(.0,nPars);
   for (size_t j=0; j<nPars; ++j)
   {
      Real& sig_j = sigma[j];
      for (size_t k=0; k<nPars; ++k)
      {
         sig_j += randVals[k]*eVector[j*nPars + k];
      }
   }
   parameterValues += sigma;
  //## end Randomizer::apply%4652F2E600C4.body
}

template <class Source, class Dist>
const RealArray* Randomizer<Source,Dist>::getCovariance (const Fit* fit)
{
  //## begin Randomizer::getCovariance%4665867500BA.body preserve=yes
   return &(m_sourceInfo.covariance(fit));
  //## end Randomizer::getCovariance%4665867500BA.body
}

template <class Source, class Dist>
void Randomizer<Source,Dist>::doInitializeLoad ()
{
  //## begin Randomizer::doInitializeLoad%4666D6120064.body preserve=yes
   m_sourceInfo.validate(initString());
  //## end Randomizer::doInitializeLoad%4666D6120064.body
}

// Additional Declarations
  //## begin Randomizer%4629005600BB.declarations preserve=yes
  //## end Randomizer%4629005600BB.declarations

//## begin module%4628FC6703BB.epilog preserve=yes
//## end module%4628FC6703BB.epilog


#endif
